
/* ParsTools.h
 * SBC++ (soccer client for Robocup2000)
 * Eslam Nazemi<nazemi@cc.sbu.ac.ir>
 * Amin Abbaspour<a-abbaspour@ce.sbu.ac.ir>
 * Mahmood Rahmani<m-rahmani@ce.sbu.ac.ir>
 * Bahman Radjabalipoor<b-radjabalipoor@ce.sbu.ac.ir>
 * Computer Department
 * Shahid Beheshti University
*/


#ifndef __PARSE_TOOLS_H
#define __PARSE_TOOLS_H

#include <stdio.h>

#include "NetHeader.h"
#include "NetNodes.h"
#include "NetFuncs.h"

class TParseTools : public TNetCommand, public TNetBehave
{
private:
    FILE *in;
    void Initialize();
    void OpenFile(const char *sFileName);
    void CleanParseString();

    int     iBlockNum;
    int     iCompBlockNum;
    int     iGoalBlockNum;

protected:
    char    sParseString[ParseBlockMaxLength][STRLEN];

public:
    TParseTools(const char *sFileName);
    ~TParseTools();

    void PreParse(const char *sFileName);
    Bool ReadNextBlock(void);
    int  BlockType();
    void CloseFile();
    void ParseCompetence(TCompetence& newComp);
    void ParseGoal(TGoal& newGoal);

    inline int  GetCompBlockNum() const { return iCompBlockNum; }
    inline int  GetGoalBlockNum() const { return iGoalBlockNum; }
    inline int  GetBlockNum() const { return iBlockNum; }

};

#endif //__PARSE_TOOLS_H